## mingw-w64-qt6-grpc-6.7.2-2.src.tar.zst

=== src/grpcquick/CMakeLists.txt ===
# Copyright (C) 2023 The Qt Company Ltd.
# SPDX-License-Identifier: BSD-3-Clause

qt_internal_add_qml_module(GrpcQuick
    URI QtGrpc
    VERSION ${CMAKE_PROJECT_VERSION}
    PLUGIN_TARGET grpcquickplugin
    CLASS_NAME GrpcQuickPlugin
    SOURCES
        qqmlabstractgrpcchannel.h
        qqmlgrpchttp2channel_p.h qqmlgrpchttp2channel.cpp
        qqmlgrpcchanneloptions_p.h qqmlgrpcchanneloptions.cpp
        qqmlgrpccalloptions_p.h qqmlgrpccalloptions.cpp
        qqmlgrpcmetadata_p.h qqmlgrpcmetadata.cpp
    LIBRARIES
        Qt::Core
        Qt::Grpc
    PUBLIC_LIBRARIES
        Qt::Quick
    GENERATE_CPP_EXPORTS
)

qt_internal_extend_target(GrpcQuick CONDITION QT_FEATURE_qml_ssl
    LIBRARIES
        Qt::QmlNetwork
        Qt::QmlNetworkPrivate
)

=== examples/grpc/magic8ball/CMakeLists.txt ===
# Copyright (C) 2023 The Qt Company Ltd.
# SPDX-License-Identifier: LicenseRef-Qt-Commercial OR BSD-3-Clause

cmake_minimum_required(VERSION 3.16)
project(Magic8Ball LANGUAGES CXX)

if(NOT DEFINED INSTALL_EXAMPLESDIR)
    set(INSTALL_EXAMPLESDIR "examples")
endif()

set(INSTALL_EXAMPLEDIR "${INSTALL_EXAMPLESDIR}/grpc/magic8ball")

find_package(Qt6 REQUIRED COMPONENTS
    Core
    Protobuf
    Grpc
    GrpcQuick
    Quick
)

qt_standard_project_setup()

add_subdirectory(grpc_server_example)

qt_add_executable(magic8ball
    main.cpp
)

qt_add_protobuf(magic8ball_plugin
    PROTO_FILES
        proto/exampleservice.proto
    QML
)

qt_add_grpc(magic8ball_plugin CLIENT
    PROTO_FILES
        proto/exampleservice.proto
    QML
)

set_target_properties(magic8ball PROPERTIES
    WIN32_EXECUTABLE TRUE
    MACOSX_BUNDLE TRUE
)

qt_add_qml_module(magic8ball
    URI qtgrpc.examples.magic8ball
    VERSION 1.0
    RESOURCE_PREFIX "/qt/qml"
    QML_FILES
        "WaitingAnimation.qml"
        "AnimatedAnswer.qml"
        "MagicText.qml"
        "ProgressDot.qml"
        "Main.qml"
)

target_link_libraries(magic8ball PRIVATE
    Qt6::Core
    Qt6::Quick
    Qt6::Protobuf
    Qt6::Grpc
    Qt6::GrpcQuick
    magic8ball_plugin
)

install(TARGETS magic8ball
    RUNTIME DESTINATION "${INSTALL_EXAMPLEDIR}"
    BUNDLE DESTINATION "${INSTALL_EXAMPLEDIR}"
    LIBRARY DESTINATION "${INSTALL_EXAMPLEDIR}"
)

=== tests/auto/grpcgen/CMakeLists.txt ===
# Copyright (C) 2022 The Qt Company Ltd.
# SPDX-License-Identifier: BSD-3-Clause

if(NOT QT_BUILD_STANDALONE_TESTS AND NOT QT_BUILDING_QT)
    cmake_minimum_required(VERSION 3.16)
    project(tst_qtgrpcgen LANGUAGES CXX)
    find_package(Qt6BuildInternals REQUIRED COMPONENTS STANDALONE_TEST)
endif()

qt_internal_add_test(tst_qtgrpcgen
    SOURCES
        tst_qtgrpcgen.cpp
    LIBRARIES
        Qt::Test
        Qt::Protobuf
        Qt::Grpc
    DEFINES
        PROTOC_EXECUTABLE="$<TARGET_FILE:WrapProtoc::WrapProtoc>"
)

qt_add_protobuf(tst_qtgrpcgen
    OUTPUT_DIRECTORY
        "${CMAKE_CURRENT_BINARY_DIR}/qt_grpc_generated/folder"
    GENERATE_PACKAGE_SUBFOLDERS
    PROTO_FILES
        ../shared/data/proto/testservice.proto
)

qt_add_grpc(tst_qtgrpcgen CLIENT
    PROTO_FILES
        ../shared/data/proto/testservice.proto
    GENERATE_PACKAGE_SUBFOLDERS
    OUTPUT_DIRECTORY "${CMAKE_CURRENT_BINARY_DIR}/qt_grpc_generated/folder"
)

qt_autogen_tools_initial_setup(tst_qtgrpcgen)


qt_add_grpc(tst_qtgrpcgen_client_grpc_only CLIENT
    PROTO_FILES
        ../shared/data/proto/testservice.proto
    GENERATE_PACKAGE_SUBFOLDERS
    OUTPUT_DIRECTORY "${CMAKE_CURRENT_BINARY_DIR}/qt_grpc_generated/separate/grpc"
)
qt_autogen_tools_initial_setup(tst_qtgrpcgen_client_grpc_only)

qt_add_protobuf(tst_qtgrpcgen_protobuf_only
    OUTPUT_DIRECTORY
        "${CMAKE_CURRENT_BINARY_DIR}/qt_grpc_generated/separate/protobuf"
    GENERATE_PACKAGE_SUBFOLDERS
    PROTO_FILES
        ../shared/data/proto/testservice.proto
)
qt_autogen_tools_initial_setup(tst_qtgrpcgen_protobuf_only)

target_link_libraries(tst_qtgrpcgen_client_grpc_only PRIVATE tst_qtgrpcgen_protobuf_only)

add_dependencies(tst_qtgrpcgen tst_qtgrpcgen_client_grpc_only)

if(TARGET Qt6::Qml)
    qt_internal_extend_target(tst_qtgrpcgen
        DEFINES
            HAVE_QML
    )

    qt_add_protobuf(tst_qtgrpcgen_plugin
        OUTPUT_DIRECTORY
            "${CMAKE_CURRENT_BINARY_DIR}/qt_grpc_generated_qml/qml"
        PROTO_FILES
            ../shared/data/proto/testservice.proto
    )

    qt_add_grpc(tst_qtgrpcgen_plugin CLIENT
        PROTO_FILES
            ../shared/data/proto/testservice.proto
        QML
        OUTPUT_DIRECTORY "${CMAKE_CURRENT_BINARY_DIR}/qt_grpc_generated_qml/qml"
    )

    qt_autogen_tools_initial_setup(tst_qtgrpcgen_plugin)
    if(QT_BUILD_STANDALONE_TESTS)
        qt_import_qml_plugins(tst_qtgrpcgen_plugin)
    endif()

    add_dependencies(tst_qtgrpcgen tst_qtgrpcgen_plugin)
endif()

=== tests/auto/grpcquick/CMakeLists.txt ===
# Copyright (C) 2023 The Qt Company Ltd.
# SPDX-License-Identifier: BSD-3-Clause

# Set the default message latency for the gRPC tests in milliseconds.
add_compile_definitions(QT_GRPC_TEST_MESSAGE_LATENCY=${QT_INTERNAL_GRPC_TEST_MESSAGE_LATENCY_MSEC})

add_subdirectory(client)
add_subdirectory(metadata)
add_subdirectory(options)
add_subdirectory(http2channel)
add_subdirectory(calloptions)

=== tests/auto/protobuf/CMakeLists.txt ===
# Copyright (C) 2022 The Qt Company Ltd.
# SPDX-License-Identifier: BSD-3-Clause

# Basic functionality
if(TARGET Qt6::qtprotobufgen)
    get_target_property(protoc_version WrapProtoc::WrapProtoc _qt_internal_protobuf_version)

    add_subdirectory(basic)
    add_subdirectory(json)
    add_subdirectory(syntax)
    add_subdirectory(nopackage)
    add_subdirectory(enums)
    add_subdirectory(externalpackage)
    add_subdirectory(sequence)
    add_subdirectory(extranamespace)
    add_subdirectory(nested)
    add_subdirectory(converters)
    add_subdirectory(duplicated_metatypes)
    add_subdirectory(recursive)
    if(protoc_version VERSION_GREATER_EQUAL "3.12")
        add_subdirectory(optional)
    endif()

    if(TARGET Qt6::ProtobufWellKnownTypes)
        add_subdirectory(wellknown)
    endif()
endif()
add_subdirectory(qprotobuflazymessagepointer)
add_subdirectory(qprotobufoneof)

=== tests/auto/protobufgen/CMakeLists.txt ===
# Copyright (C) 2022 The Qt Company Ltd.
# SPDX-License-Identifier: BSD-3-Clause

if(NOT QT_BUILD_STANDALONE_TESTS AND NOT QT_BUILDING_QT)
    cmake_minimum_required(VERSION 3.16)
    project(tst_qtprotobufgen LANGUAGES CXX)
    find_package(Qt6BuildInternals REQUIRED COMPONENTS STANDALONE_TEST)
endif()

qt_internal_add_test(tst_qtprotobufgen
    SOURCES
        tst_qtprotobufgen.cpp
    LIBRARIES
        Qt::Test
        Qt::Protobuf
    DEFINES
        PROTOC_EXECUTABLE="$<TARGET_FILE:WrapProtoc::WrapProtoc>"
)

qt_add_protobuf(tst_qtprotobufgen
    PROTO_FILES
        ../shared/data/proto/annotation.proto
    COPY_COMMENTS
    OUTPUT_DIRECTORY "${CMAKE_CURRENT_BINARY_DIR}/qt_protobuf_generated/comments"
)

qt_add_protobuf(tst_qtprotobufgen
    PROTO_FILES
        ../shared/data/proto/fieldindexrange.proto
    OUTPUT_DIRECTORY "${CMAKE_CURRENT_BINARY_DIR}/qt_protobuf_generated/fieldenum"
)

qt_add_protobuf(tst_qtprotobufgen
    PROTO_FILES
        ../shared/data/proto/extranamespace.proto
    EXTRA_NAMESPACE
        MyTopLevelNamespace
    OUTPUT_DIRECTORY "${CMAKE_CURRENT_BINARY_DIR}/qt_protobuf_generated/extra-namespace"
)

add_library(tst_qtprotobufgen_gen SHARED)
qt_add_protobuf(tst_qtprotobufgen_gen
    PROTO_FILES
        ../shared/data/proto/basicmessages.proto
        ../shared/data/proto/mapmessages.proto
        ../shared/data/proto/oneofmessages.proto
        ../shared/data/proto/repeatedmessages.proto
        ../shared/data/proto/optional.proto
    GENERATE_PACKAGE_SUBFOLDERS
    OUTPUT_DIRECTORY "${CMAKE_CURRENT_BINARY_DIR}/qt_protobuf_generated/folder"
)
qt_autogen_tools_initial_setup(tst_qtprotobufgen_gen)

add_library(tst_qtprotobufgen_custom_exports_gen SHARED)
qt_add_protobuf(tst_qtprotobufgen_custom_exports_gen
    PROTO_FILES
        ../shared/data/proto/basicmessages.proto
    EXPORT_MACRO "CUSTOM_EXPORT_NAME"
    OUTPUT_DIRECTORY "${CMAKE_CURRENT_BINARY_DIR}/qt_protobuf_generated/custom-exports"
)
qt_autogen_tools_initial_setup(tst_qtprotobufgen_custom_exports_gen)

add_library(tst_qtprotobufgen_no_exports_gen STATIC)
qt_add_protobuf(tst_qtprotobufgen_no_exports_gen
    PROTO_FILES
        ../shared/data/proto/basicmessages.proto
    EXPORT_MACRO "CUSTOM_EXPORT_NAME"
    OUTPUT_DIRECTORY "${CMAKE_CURRENT_BINARY_DIR}/qt_protobuf_generated/no-exports"
)
qt_autogen_tools_initial_setup(tst_qtprotobufgen_no_exports_gen)

qt_add_protobuf(tst_qtprotobufgen
    PROTO_FILES
        ../shared/data/proto/repeatednonpackedmessages.proto
    OUTPUT_DIRECTORY "${CMAKE_CURRENT_BINARY_DIR}/qt_protobuf_generated/packed"
)
qt_autogen_tools_initial_setup(tst_qtprotobufgen)

if(MINGW)
    target_compile_options(tst_qtprotobufgen PRIVATE "-Wa,-mbig-obj")
    target_compile_options(tst_qtprotobufgen_gen PRIVATE "-Wa,-mbig-obj")
endif()

get_target_property(protoc_version WrapProtoc::WrapProtoc _qt_internal_protobuf_version)
if(protoc_version VERSION_GREATER_EQUAL "3.12" AND protoc_version VERSION_LESS "3.15")
    qt_internal_extend_target(tst_qtprotobufgen
        DEFINES
            ALLOW_PROTO3_OPTIONAL
    )
endif()

add_dependencies(tst_qtprotobufgen tst_qtprotobufgen_gen tst_qtprotobufgen_custom_exports_gen)

if(TARGET Qt6::Qml)
    qt_internal_extend_target(tst_qtprotobufgen
        DEFINES
            HAVE_QML
    )

    qt_add_protobuf(tst_qtprotobufgen_qml_gen
        PROTO_FILES
        ../shared/data/proto/basicmessages.proto
        ../shared/data/proto/repeatedmessages.proto
        ../shared/data/proto/oneofmessages.proto
        ../protobuf/enums/enummessages.proto
        QML
        OUTPUT_DIRECTORY "${CMAKE_CURRENT_BINARY_DIR}/qt_protobuf_generated/qmlgen"
    )
    qt_autogen_tools_initial_setup(tst_qtprotobufgen_qml_gen)
    qt_autogen_tools_initial_setup(tst_qtprotobufgen_qml_genplugin)

    qt_add_protobuf(tst_qtprotobufgen_nopackage_qml_gen
        PROTO_FILES
            ../shared/data/proto/nopackage.proto
            ../shared/data/proto/nopackageexternal.proto
        QML
        QML_URI "nopackage.uri.test"
        OUTPUT_DIRECTORY "${CMAKE_CURRENT_BINARY_DIR}/qt_protobuf_generated/qml-no-package"
    )
    qt_autogen_tools_initial_setup(tst_qtprotobufgen_nopackage_qml_gen)
    qt_autogen_tools_initial_setup(tst_qtprotobufgen_nopackage_qml_genplugin)

    add_dependencies(tst_qtprotobufgen
        tst_qtprotobufgen_qml_gen
        tst_qtprotobufgen_nopackage_qml_gen
    )
endif()

=== examples/grpc/magic8ball/grpc_server_example/CMakeLists.txt ===
# Copyright (C) 2022 The Qt Company Ltd.
# SPDX-License-Identifier: LicenseRef-Qt-Commercial OR BSD-3-Clause

cmake_minimum_required(VERSION 3.16)
project(MagicServerRunner LANGUAGES CXX)

# Qt6::Grpc module is not used directly in this project. But this allows to find Qt6::Grpc's
# dependencies without setting extra cmake module paths.
find_package(Qt6 COMPONENTS Grpc)
find_package(WrapgRPCPlugin)
find_package(WrapgRPC)

if(NOT TARGET WrapgRPC::WrapgRPCPlugin OR NOT TARGET WrapProtoc::WrapProtoc
    OR NOT TARGET WrapgRPC::WrapLibgRPC)
    message(WARNING "Dependencies of QtGrpc test server not found. Skipping.")
    return()
endif()

set(proto_files "${CMAKE_CURRENT_LIST_DIR}/../proto/exampleservice.proto")
set(out_dir ${CMAKE_CURRENT_BINARY_DIR})

set(generated_files
    "${out_dir}/exampleservice.pb.h" "${out_dir}/exampleservice.pb.cc"
    "${out_dir}/exampleservice.grpc.pb.h" "${out_dir}/exampleservice.grpc.pb.cc")

add_custom_command(
    OUTPUT ${generated_files}
    COMMAND
    $<TARGET_FILE:WrapProtoc::WrapProtoc>
    ARGS
    --grpc_out "${out_dir}"
    --cpp_out "${out_dir}"
    -I "${CMAKE_CURRENT_LIST_DIR}/../proto/"
    --plugin=protoc-gen-grpc=$<TARGET_FILE:WrapgRPC::WrapgRPCPlugin>
    "${proto_files}"
    WORKING_DIRECTORY ${out_dir}
    DEPENDS "${proto_files}"
    COMMENT "Generating gRPC ${target} sources..."
    COMMAND_EXPAND_LISTS
    VERBATIM
)

set_source_files_properties(${generated_files} PROPERTIES GENERATED TRUE)
add_library(ServerRunner_grpc_gen STATIC ${generated_files})
target_include_directories(ServerRunner_grpc_gen
    PRIVATE
    ${out_dir}
)

target_link_libraries(ServerRunner_grpc_gen
    PRIVATE
    WrapgRPC::WrapLibgRPC
)

add_library(MagicServerRunner
    STATIC
    serverrunner.cpp
    serverrunner.h
)

target_include_directories(MagicServerRunner PRIVATE ${out_dir})

target_link_libraries(MagicServerRunner
    PRIVATE
    ServerRunner_grpc_gen
    WrapgRPC::WrapLibgRPC
    Qt6::Core
)

qt_add_executable(SimpleGrpcServer
    main.cpp
)

target_link_libraries(SimpleGrpcServer PRIVATE
    Qt6::Core
    MagicServerRunner
)

install(TARGETS SimpleGrpcServer
    RUNTIME DESTINATION "${INSTALL_EXAMPLEDIR}"
    BUNDLE DESTINATION "${INSTALL_EXAMPLEDIR}"
    LIBRARY DESTINATION "${INSTALL_EXAMPLEDIR}"
)

=== tests/auto/grpcquick/client/CMakeLists.txt ===
# Copyright (C) 2023 The Qt Company Ltd.
# SPDX-License-Identifier: BSD-3-Clause

if(NOT QT_BUILD_STANDALONE_TESTS AND NOT QT_BUILDING_QT)
    cmake_minimum_required(VERSION 3.16)
    project(tst_grpc_client_unarycall_qml LANGUAGES CXX)
    find_package(Qt6BuildInternals REQUIRED COMPONENTS STANDALONE_TEST)
    include("../../grpc/client/shared/test_server/CMakeLists.txt")
endif()

if(NOT TARGET grpc_testserver)
    return()
endif()

qt_internal_add_test(tst_grpc_client_unarycall_qml
    QMLTEST
    SOURCES
        tst_client_qml.cpp
    INCLUDE_DIRECTORIES
        ${CMAKE_CURRENT_SOURCE_DIR}/../../grpc/shared
    DEFINES
        TEST_GRPC_SERVER_PATH="$<TARGET_FILE:grpc_testserver>"
    LIBRARIES
        Qt::Qml
        Qt::Grpc
)

qt_add_grpc(tst_grpc_client_unarycall_qml_gen CLIENT
    PROTO_FILES
        ../../shared/data/proto/testservice.proto
    QML
    OUTPUT_DIRECTORY
        "${CMAKE_CURRENT_BINARY_DIR}/qt_grpc_generated_qml"
)

qt_add_protobuf(tst_grpc_client_unarycall_qml_gen
    PROTO_FILES
        ../../shared/data/proto/testservice.proto
    QML
    QML_URI qtgrpc.tests
    OUTPUT_DIRECTORY
        "${CMAKE_CURRENT_BINARY_DIR}/qt_grpc_generated_qml"
)

qt_policy(SET QTP0001 NEW)

qt_add_qml_module(tst_grpc_client_unarycall_qml
    URI QmlTestUri
    VERSION 1.0
    QML_FILES
        qml/tst_client.qml
)

qt_autogen_tools_initial_setup(tst_grpc_client_unarycall_qml)
qt_autogen_tools_initial_setup(tst_grpc_client_unarycall_qml_gen)
qt_autogen_tools_initial_setup(tst_grpc_client_unarycall_qml_genplugin)

if(QT_BUILD_STANDALONE_TESTS)
    qt_import_qml_plugins(tst_grpc_client_unarycall_qml)
    qt_import_qml_plugins(tst_grpc_client_unarycall_qml_gen)
endif()

=== tests/auto/protobuf/wellknown/CMakeLists.txt ===
# Copyright (C) 2022 The Qt Company Ltd.
# SPDX-License-Identifier: BSD-3-Clause

if(NOT QT_BUILD_STANDALONE_TESTS AND NOT QT_BUILDING_QT)
    cmake_minimum_required(VERSION 3.16)
    project(tst_protobuf_wellknown LANGUAGES CXX)
    find_package(Qt6BuildInternals REQUIRED COMPONENTS STANDALONE_TEST)
endif()

qt_internal_add_test(tst_protobuf_any
    SOURCES
        tst_protobuf_any.cpp
    LIBRARIES
        Qt::Test
        Qt::Protobuf
        Qt::ProtobufWellKnownTypes
)

qt6_add_protobuf(tst_protobuf_any
    PROTO_FILES
        ../../shared/data/proto/anymessages.proto
    OUTPUT_DIRECTORY "${CMAKE_CURRENT_BINARY_DIR}/qt_protobuf_generated"
    PROTO_INCLUDES
        $<TARGET_PROPERTY:Qt6::ProtobufWellKnownTypes,QT_PROTO_INCLUDES>
)

qt_internal_add_test(tst_protobuf_timestamp
    SOURCES
        tst_protobuf_timestamp.cpp
    LIBRARIES
        Qt::Test
        Qt::ProtobufWellKnownTypes
)

qt6_add_protobuf(tst_protobuf_timestamp
    PROTO_FILES
        ../../shared/data/proto/timestampmessages.proto
    OUTPUT_DIRECTORY "${CMAKE_CURRENT_BINARY_DIR}/qt_protobuf_generated"
    PROTO_INCLUDES
        $<TARGET_PROPERTY:Qt6::ProtobufWellKnownTypes,QT_PROTO_INCLUDES>
    EXTRA_NAMESPACE
        MyTopLevelNamespace
)
qt_autogen_tools_initial_setup(tst_protobuf_basictypes_gen)

=== tests/auto/protobufqml/nopackage/CMakeLists.txt ===
# Copyright (C) 2023 The Qt Company Ltd.
# SPDX-License-Identifier: BSD-3-Clause

if(NOT QT_BUILD_STANDALONE_TESTS AND NOT QT_BUILDING_QT)
    cmake_minimum_required(VERSION 3.16)
    project(tst_protobuf_nopackage_qml LANGUAGES CXX)
    find_package(Qt6BuildInternals REQUIRED COMPONENTS STANDALONE_TEST)
endif()

qt_internal_add_test(tst_protobuf_nopackage_qml
    QMLTEST
    SOURCES
        tst_protobuf_nopackage_qml.cpp
    LIBRARIES
        Qt::Qml
        Qt::Protobuf
)

qt_add_protobuf(tst_protobuf_nopackage_qml_gen
    PROTO_FILES
        ../../shared/data/proto/nopackage.proto
        ../../shared/data/proto/nopackageexternal.proto
    QML
    QML_URI "nopackage.uri.test"
    OUTPUT_DIRECTORY "${CMAKE_CURRENT_BINARY_DIR}/qt_protobuf_generated"
)

qt_policy(SET QTP0001 NEW)
qt_add_qml_module(tst_protobuf_nopackage_qml
    URI QmlTestUri
    VERSION 1.0
    QML_FILES
        qml/tst_nopackage.qml
)

qt_autogen_tools_initial_setup(tst_protobuf_nopackage_qml)
qt_autogen_tools_initial_setup(tst_protobuf_nopackage_qml_gen)
qt_autogen_tools_initial_setup(tst_protobuf_nopackage_qml_genplugin)

if(QT_BUILD_STANDALONE_TESTS)
    qt_import_qml_plugins(tst_protobuf_nopackage_qml)
    qt_import_qml_plugins(tst_protobuf_nopackage_qml_gen)
endif()

=== PKGBUILD ===
# Contributor: Mehdi Chinoune <mehdi.chinoune@hotmail.com>

_realname=qt6-grpc
pkgbase=mingw-w64-${_realname}
pkgname=("${MINGW_PACKAGE_PREFIX}-${_realname}"
         "${MINGW_PACKAGE_PREFIX}-${_realname}-debug")
_qtver=6.7.2
pkgver=${_qtver/-/}
pkgrel=2
pkgdesc='Qt gRPC and Protobuf generator and bindings. (mingw-w64)'
arch=(any)
mingw_arch=('mingw64' 'ucrt64' 'clang64' 'clangarm64')
url='https://www.qt.io'
msys2_repository_url="https://code.qt.io/cgit/qt/qtgrpc.git"
msys2_references=(
  'archlinux: qt6-grpc'
  "cpe: cpe:/a:qt:qt"
)
license=('spdx:LGPL-3.0-only WITH Qt-GPL-exception-1.0 AND BSD-3-Clause AND GFDL-1.3-no-invariants-only AND GPL-2.0-only AND GPL-3.0-only')
makedepends=("${MINGW_PACKAGE_PREFIX}-cc"
             "${MINGW_PACKAGE_PREFIX}-cmake"
             "${MINGW_PACKAGE_PREFIX}-ninja"
             "${MINGW_PACKAGE_PREFIX}-qt6-base"
             "${MINGW_PACKAGE_PREFIX}-qt6-declarative"
             "${MINGW_PACKAGE_PREFIX}-grpc"
             "${MINGW_PACKAGE_PREFIX}-protobuf"
             "rsync")
_pkgfn="${_realname/6-/}-everywhere-src-${_qtver}"
source=("https://download.qt.io/official_releases/qt/${pkgver%.*}/${_qtver}/submodules/${_pkgfn}.tar.xz")
sha256sums=('8d9f853e040acdec9bb5c71ab1ab335e32c333233a47584771e85ce076a2e17e')

build() {
  mkdir -p build-${MSYSTEM} && cd build-${MSYSTEM}

  MSYS2_ARG_CONV_EXCL="-DCMAKE_INSTALL_PREFIX=" \
  ${MINGW_PREFIX}/bin/cmake \
    --log-level=STATUS \
    -GNinja \
    -DCMAKE_BUILD_TYPE=RelWithDebInfo \
    -DCMAKE_INSTALL_PREFIX=${MINGW_PREFIX} \
    ../${_pkgfn}

  ${MINGW_PREFIX}/bin/cmake --build .
}

package_qt6-grpc() {
  depends=("${MINGW_PACKAGE_PREFIX}-qt6-base"
           "${MINGW_PACKAGE_PREFIX}-abseil-cpp"
           "${MINGW_PACKAGE_PREFIX}-grpc"
           "${MINGW_PACKAGE_PREFIX}-protobuf"
           "${MINGW_PACKAGE_PREFIX}-libwinpthread-git")
  optdepends=("${MINGW_PACKAGE_PREFIX}-qt6-declarative")
  groups=("${MINGW_PACKAGE_PREFIX}-qt6")

  DESTDIR=${pkgdir} ${MINGW_PREFIX}/bin/cmake --install build-${MSYSTEM}

  # Seperate debug-info files
  rsync -armR --remove-source-files --include="*/" --include="*.debug" --exclude="*" --prune-empty-dirs ${pkgdir}/.${MINGW_PREFIX} ${srcdir}/${MSYSTEM}-debug/

  install -d "$pkgdir${MINGW_PREFIX}"/share/licenses/${_realname}
  install -Dm644 $_pkgfn/LICENSES/* -t "$pkgdir${MINGW_PREFIX}"/share/licenses/${_realname}
}

package_qt6-grpc-debug() {
  depends=("${MINGW_PACKAGE_PREFIX}-qt6-base-debug"
           "${MINGW_PACKAGE_PREFIX}-${_realname}")
  groups=("${MINGW_PACKAGE_PREFIX}-qt6-debug")
  options=('!strip')

  cp -rf ${srcdir}/${MSYSTEM}-debug${MINGW_PREFIX} "${pkgdir}"/
}

# template start; name=mingw-w64-splitpkg-wrappers; version=1.0;
# vim: set ft=bash :

# generate wrappers
for _name in "${pkgname[@]}"; do
  _short="package_${_name#${MINGW_PACKAGE_PREFIX}-}"
  _func="$(declare -f "${_short}")"
  eval "${_func/#${_short}/package_${_name}}"
done
# template end;
